package vishnu.cluster;

import java.io.*;
import java.util.*;

public class TheVectors
{
    public Vector theData;
    public int size;
    public Vector coding;
    public int zeros;


    TheVectors(String file, int VECTOR_SIZE)
    {
        theData= new Vector(VECTOR_SIZE);
	coding= new Vector(VECTOR_SIZE);
        int index,code =0, zerolist=0;
	double ssum,value;
    	try
	{
      	    FileReader inFile = new FileReader(file);
      	    BufferedReader inLines = new BufferedReader(inFile);
	    size=0;
            String line = null, tokenString;
	    do
	    {

		line = inLines.readLine();
		if (line!= null)
		{

		  double[] row= new double[VECTOR_SIZE];
 					StringTokenizer tokens = new StringTokenizer(line," ");
                  ssum=0.0;
   		  for (index=0; index<VECTOR_SIZE; index++)
		  {
                      if(tokens.hasMoreTokens())
                      {
                          tokenString = tokens.nextToken();
           	          value = Double.parseDouble(tokenString);
		          row[index]= value;
		          ssum+= value*value;
                      }
                      else
                      {
                          row[index]=0.0;
                      }
	          }
	          if(index==0) continue;
                  ssum=Math.sqrt(ssum);
	          if(ssum!=0.0)
	          {
	              for(int i=0;i<index;i++)
		      row[i]/=ssum;
		      theData.addElement(row);
		      coding.addElement(new TheInt(code));
                      size++;
		  }
		  else
		  {
		      if(zerolist==0)
		      {
			//System.out.print("0 ");
	                  zerolist=1;
		      }
		      System.out.print(code + " ");
		  }
	      }
	      code++;
	  }while(line != null);
	}
	catch(IOException e)
	{
	    System.err.println("IO Exception in read_vectors");
	    e.printStackTrace();
        }
    }
}
